import numpy
#import Test3DDatan
import math


def read_file(filename):
    f = open(filename, 'r')
    outarray = []
    for line in f.readlines():
        split = line.strip().split()
        outarray.append([ float(item) for item in split ])
    print "done reading file ", filename
    f.close()
    return numpy.array(outarray).squeeze()


def calc_optbin(rA_MeasLoc):
    if len(rA_MeasLoc.shape) == 1:
        dimension = 1
        print '1D'
    else:
        dimension = rA_MeasLoc.shape[1]
        Anzahl = rA_MeasLoc.shape[0]
        bezug = rA_MeasLoc[0, :]
        abstand = numpy.zeros(rA_MeasLoc.shape)
        mini = numpy.array([100., 100., 100])
        for i in range (0, Anzahl):
            abstand[i] = abs(rA_MeasLoc[i, :] - bezug)
            for j in range (0, dimension):
                if abstand[i, j] < mini[j]:
                    if abstand[i, j] > 0.0:
                        mini[j] = abstand[i, j]

        if dimension > 2:
            if mini[0] == mini[1]:
                bin_hor = mini[0]
            if mini[0] > mini[1]:
                bin_hor = mini[1]
            if mini[0] < mini[1]:
                bin_hor = mini[0]
        else:
            bin_hor = mini[0]
        bin_vert = mini[dimension - 1]

    return bin_hor, bin_vert




##def calcAngleMatrix(pointsA, pointsB):
##    """function to calculate the euclidean distances between all points of two sets.
##    pointsA and pointsB are (npoints x dimension) numpy arrays containing
##    the cartesian coordinates of the points (one point per row)
##    The number of points in pointsA and pointsB need not be the same.
##    The result will be a (npointsA x npointsB)-numpy array
##
##    Examples:
##    in 2-D
##    >>> pointsA = numpy.array([[0.0, 0.0], [1.0, 0.0]])
##    >>> pointsB = numpy.array([[0.0, 1.0], [1.0, 1.0]])
##    >>> calcDistanceMatrix(pointsA, pointsB)
##    array([[ 1.        ,  1.41421356],
##           [ 1.41421356,  1.        ]])
##
##    in 3-D
##    >>> pointsA = numpy.array([[0.0, 0.0, 0.0], [1.0, 0.0, 0.0]])
##    >>> pointsB = numpy.array([[0.0, 1.0, 0.0], [1.0, 1.0, 0.0]])
##    >>> calcDistanceMatrix(pointsA, pointsB)
##    array([[ 1.        ,  1.41421356],
##           [ 1.41421356,  1.        ]])
##
##    With different numbers of points
##    >>> pointsA = numpy.array([[0.0, 0.0]])
##    >>> pointsB = numpy.array([[0.0,1.0], [1.0, 1.0]])
##    >>> calcDistanceMatrix(pointsA, pointsB)
##    array([[ 1.        ,  1.41421356]])
##
##    Can also be used to calculate all distances within the same set of points
##    >>> points = numpy.array([ [1.,1.],[-1.,-1.],[0.5,-1.1],[-0.8,0.9]])
##    >>> calcDistanceMatrix(points, points)
##    array([[ 0.        ,  2.82842712,  2.15870331,  1.80277564],
##           [ 2.82842712,  0.        ,  1.50332964,  1.91049732],
##           [ 2.15870331,  1.50332964,  0.        ,  2.38537209],
##           [ 1.80277564,  1.91049732,  2.38537209,  0.        ]])
##
##    Points should be of the same dimension
##    >>> pointsA = numpy.array([[0.0, 0.0, 0.0], [1.0, 0.0, 0.0]])
##    >>> pointsB = numpy.array([[0.0, 1.0], [1.0, 1.0]])
##    >>> calcDistanceMatrix(pointsA, pointsB)
##    Traceback (most recent call last):
##    ...
##    AssertionError: Dimension of points has to be the same (dimA=3) != (2=dimB
##    """
##    # make sure the dimensions of both point sets are the same
####    assert pointsA.shape[1] == pointsB.shape[1], \
####        'Dimension of points has to be the same (dimA=%i) != (%i=dimB' % \
####        (pointsA.shape[1], pointsB.shape[1])
##
##    # set up some variables
##    npointsA = pointsA.shape[0]
##    npointsB = pointsB.shape[0]
##
##    # initialize our result matrix and the helper vectors
##    anglematrix = numpy.zeros((npointsA, npointsB))
##
##
##    #  y part
##    yparta = numpy.mat(numpy.ones((2,npointsA)))
##    yparta[0,:] = pointsA[:, 1]
##
##    ypartb = numpy.mat(numpy.ones((2,npointsB)) * -1)
##    ypartb[1,:] = pointsB[:, 1]
##
##    ydifference = numpy.asarray((yparta.T * ypartb))
##
##    #  x part
##    xparta = numpy.mat(numpy.ones((2,npointsA)))
##    xparta[0,:] = pointsA[:, 0]
##
##    xpartb = numpy.mat(numpy.ones((2,npointsB)) * -1)
##    xpartb[1,:] = pointsB[:, 0]
##
##    xdifference = numpy.asarray((xparta.T * xpartb))
##
##
##    # calculate angles
##    angle_hilf = ydifference / xdifference
##    angle = numpy.arctan(angle_hilf) * 360. / (2 * math.pi)
##
##
##    return angle

def calcAngleMatrices(pointsA, pointsB):
    # this is used to calculate the two anglematrices alpha and beta
    #   as done with and defined by Maria

    # set up some variables
    npointsA = pointsA.shape[0]
    npointsB = pointsB.shape[0]
    # initialize our result matrix and the helper vectors
    anglematrix = numpy.zeros((npointsA, npointsB))
    differences = []

    # for 1D
    if len(pointsA.shape) == 1:
        dimension = 1
        print '1D --> kein alpha'
##        # create numpy matrix for points A
##        xxa = numpy.mat(numpy.ones((2,npointsA)))
##        xxa[0,:] = pointsA[:,]
##
##        # create numpy matrix for points B
##        xxb = numpy.mat(numpy.ones((2,npointsB)) * -1)
##        xxb[1,:] = pointsB[:,]
##
##        # calculate distance matrix summand using matrix product
##        # the squaring afterwards has to be done elementwise and therfore
##        # the resulting matrix has to be converted to array before doing the
##        # power operation
##        differences.append( numpy.asarray((xxa.T * xxb))**2 )
##
##        # final steps
##        indices_dx0 = numpy.where(differences[0]==0)
##        #indices_dz0 = numpy.where(differences[2]==0)
##
##        hypo = (differences[0]**2 + differences[1]**2)**0.5
##
##        alpha = numpy.abs(numpy.arctan(hypo/differences[2])* 360. / (2 * math.pi))   # Winkel zur z-Achse
##        alpha[indices_dz0] = 90.0
##
##        beta = numpy.abs(numpy.arctan(differences[1]/differences[0])* 360. / (2 * math.pi))     # Winkel zur x-Achse
##        beta[indices_dx0] = 90.0
##
##        return alpha, beta

    # for higher dimensions than 1D
    else:
        dimension = pointsA.shape[1]

        for dim in range(dimension):
            # create numpy matrix for points A
            xxa = numpy.mat(numpy.ones((2, npointsA)))
            xxa[0, :] = pointsA[:, dim]

            # create numpy matrix for points B
            xxb = numpy.mat(numpy.ones((2, npointsB)) * -1)
            xxb[1, :] = pointsB[:, dim]

            # calculate distance matrix summand using matrix product
            # the squaring afterwards has to be done elementwise and therfore
            # the resulting matrix has to be converted to array before doing the
            # power operation
            differences.append(numpy.asarray((xxa.T * xxb)) ** 2)   # differences:abstand**2 !!!!!!!!!!!!!!!!!!!!!!!!!!!!
        differences = numpy.array(differences)
        dz = numpy.sqrt(differences[dimension - 1])

        # final steps
       # indices_dx0 = numpy.where(differences[0]==0)
        #indices_dz0 = numpy.where(differences[2]==0)

        # braucht man nur fuer alpha, also nur x,y

        Boden = numpy.zeros(numpy.shape(differences[0]))
        for i in range (dimension - 1):
            xy = differences[i]
            Boden = Boden + xy

        Boden = numpy.array(Boden)
        abstBoden = numpy.sqrt(Boden)

##        alpha = numpy.abs(numpy.arctan(abstBoden/dz)* 360. / (2 * math.pi))   # Winkel zur z-Achse
##        alpha[indices_dz0] = 90.0

        alpha = numpy.abs(numpy.arctan(dz / abstBoden) * 360. / (2 * math.pi))
        #alpha[abstBoden==0]=


##        beta = numpy.abs(numpy.arctan(differences[1]/differences[0])* 360. / (2 * math.pi))     # Winkel zur x-Achse
##        beta[indices_dx0] = 90.0

        return alpha   #, beta



def calcDistanceMatrix(pointsA, pointsB):
    """function to calculate the euclidean distances between all points of two sets.
    pointsA and pointsB are (npoints x dimension) numpy arrays containing
    the cartesian coordinates of the points (one point per row)
    The number of points in pointsA and pointsB need not be the same.
    The result will be a (npointsA x npointsB)-numpy array

    Examples:
    in 2-D
    >>> pointsA = numpy.array([[0.0, 0.0], [1.0, 0.0]])
    >>> pointsB = numpy.array([[0.0, 1.0], [1.0, 1.0]])
    >>> calcDistanceMatrix(pointsA, pointsB)
    array([[ 1.        ,  1.41421356],
           [ 1.41421356,  1.        ]])

    in 3-D
    >>> pointsA = numpy.array([[0.0, 0.0, 0.0], [1.0, 0.0, 0.0]])
    >>> pointsB = numpy.array([[0.0, 1.0, 0.0], [1.0, 1.0, 0.0]])
    >>> calcDistanceMatrix(pointsA, pointsB)
    array([[ 1.        ,  1.41421356],
           [ 1.41421356,  1.        ]])

    With different numbers of points
    >>> pointsA = numpy.array([[0.0, 0.0]])
    >>> pointsB = numpy.array([[0.0,1.0], [1.0, 1.0]])
    >>> calcDistanceMatrix(pointsA, pointsB)
    array([[ 1.        ,  1.41421356]])

    Can also be used to calculate all distances within the same set of points
    >>> points = numpy.array([ [1.,1.],[-1.,-1.],[0.5,-1.1],[-0.8,0.9]])
    >>> calcDistanceMatrix(points, points)
    array([[ 0.        ,  2.82842712,  2.15870331,  1.80277564],
           [ 2.82842712,  0.        ,  1.50332964,  1.91049732],
           [ 2.15870331,  1.50332964,  0.        ,  2.38537209],
           [ 1.80277564,  1.91049732,  2.38537209,  0.        ]])

    Points should be of the same dimension
    >>> pointsA = numpy.array([[0.0, 0.0, 0.0], [1.0, 0.0, 0.0]])
    >>> pointsB = numpy.array([[0.0, 1.0], [1.0, 1.0]])
    >>> calcDistanceMatrix(pointsA, pointsB)
    Traceback (most recent call last):
    ...
    AssertionError: Dimension of points has to be the same (dimA=3) != (2=dimB
    """
    # make sure the dimensions of both point sets are the same
##    assert pointsA.shape[1] == pointsB.shape[1], \
##        'Dimension of points has to be the same (dimA=%i) != (%i=dimB' % \
##        (pointsA.shape[1], pointsB.shape[1])

    # set up some variables
    npointsA = pointsA.shape[0]
    npointsB = pointsB.shape[0]
    # initialize our result matrix and the helper vectors
    distmatrix = numpy.zeros((npointsA, npointsB))

    # wenn 1D
    if len(pointsA.shape) == 1:
        dimension = 1
        xxa = numpy.mat(numpy.ones((2, npointsA)))
        xxa[0, :] = pointsA[:, ]

        # create numpy matrix for points B
        xxb = numpy.mat(numpy.ones((2, npointsB)) * -1)
        xxb[1, :] = pointsB[:, ]

        # calculate distance matrix summand using matrix product
        # the squaring afterwards has to be done elementwise and therfore
        # the resulting matrix has to be converted to array before doing the
        # power operation
        distmatrix += numpy.asarray((xxa.T * xxb)) ** 2
         # return the result
        return numpy.sqrt(distmatrix)

    # mehr-dimensional als 1D
    else:
        dimension = pointsA.shape[1]
        # for each dimension calculate the squared differences and add them to
        # the distance matrix
        for dim in range(dimension):
            # create numpy matrix for points A
            xxa = numpy.mat(numpy.ones((2, npointsA)))
            xxa[0, :] = pointsA[:, dim]

            # create numpy matrix for points B
            xxb = numpy.mat(numpy.ones((2, npointsB)) * -1)
            xxb[1, :] = pointsB[:, dim]

            # calculate distance matrix summand using matrix product
            # the squaring afterwards has to be done elementwise and therfore
            # the resulting matrix has to be converted to array before doing the
            # power operation
            distmatrix += numpy.asarray((xxa.T * xxb)) ** 2

        # return the result
        return numpy.sqrt(distmatrix)

# obsolete; calcDistanceMatrix ist generischer und funktioniert auch in 3D
##def distance_matrix3D(rA_MeasLoc):
##    sI_n = len(rA_MeasLoc)
##    rV_x = numpy.array(rA_MeasLoc[:,0])
##    rV_y = numpy.array(rA_MeasLoc[:,1])
##    rV_z = numpy.array(rA_MeasLoc[:,2])
##
##    ones = numpy.ones(sI_n)
##
##    xi = numpy.outer(rV_x, ones)
##    xj = numpy.outer(ones, rV_x)
##
##    yi = numpy.outer(rV_y, ones)
##    yj = numpy.outer(ones, rV_y)
##
##    zi = numpy.outer(rV_z, ones)
##    zj = numpy.outer(ones, rV_z)
##
##    r = numpy.sqrt((xi - xj)**2 + (yi - yj)**2 + (zi - zj)**2 )
##    return r


def KernelSmoothing(RasterX, RasterY, X, Y, Radius):

    pointsA = numpy.column_stack((X, Y))
    pointsB = numpy.column_stack((RasterX, RasterY))

    # todo: Reihenfolge ist wichtig! pointsA zuerst oder pointsB zuerst?!?
#    print "inside Kernel Smoothing"
#    print "shape pointsA: ", numpy.shape(pointsA)
#    print "shape pointsB: ", numpy.shape(pointsB)

    # todo: das muss eigentlich rauss in das calling routine!

    Dist = calcDistanceMatrix(pointsA, pointsB)

    #print Dist

    Wtemp = 1 - (Dist / Radius)
    # todo: change this to be more effective as well!
    #print Wtemp

    W = Wtemp.clip(min=0, max=9999999999.)
    # print W

    KernelSum = W.sum(axis=0)
    # print KernelSum


    return KernelSum

def frange(start, end=None, inc=None):
    "A range function, that does accept float increments..."

    if end == None:
        end = start + 0.0
        start = 0.0
    else: start += 0.0 # force it to be a float

    if inc == None:
        inc = 1.0

    count = int((end - start) / inc)
    if start + count * inc != end:
        # need to adjust the count.
        # AFAIKT, it always comes up one short.
        count += 1

    L = [None, ] * count
    for i in xrange(count):
        L[i] = start + i * inc

    return L

def MatrixIntegrieren(a):
    ar = numpy.flipud(a)
    at = numpy.transpose(ar)
    aFold = numpy.add.accumulate(at, axis=1)
    aBackTr = numpy.transpose(aFold)
    aFold2 = numpy.add.accumulate(aBackTr, axis=1)
    FinalResult = numpy.flipud(aFold2)
    return FinalResult

def MatrixDifferenzieren(a):
    sCr = numpy.flipud(a)
    # Differentiation im Sinne eines "Kernel"
    sCr[:, 1:] = sCr[:, 1:] - sCr[:, :-1]
    sCr2 = numpy.transpose(sCr)
    sCr2[:, 1:] = sCr2[:, 1:] - sCr2[:, :-1]
    sCr3 = numpy.transpose(sCr2)
    sCr4 = numpy.flipud(sCr3)
    return sCr4
